#ifndef NITPICKER_CONFIG_H
#define NITPICKER_CONFIG_H

#include "types.h"

#define HASHSIZE         199961
#define MAXFLOWSINTIMEQ    5000  /* Max size of timeQ (when reaching the limit, flows are directly moved to saveQ) */ 
#define FLOWSPERFILE      10000  /* How many Flows per Flowfile */
#define FLOWTIMEOUT         600  /* when flows are moved from timeQ into saveQ */

#define STATDELAY            30  /* Dump Statistics (Stats-Line) every n seconds */

#define BPF_BUF     8*1024*1024  /* 8MBytes could be enough */
#define BPF_TIMEOUT           1  /* Read should timeout after 1 sec. */

/* Return somd hash between 0 and m depending on the 32Bit p */
#define HASHFUNC(p,m) (((p)^((p)>>7)^((p)>>15)^((p)>>23)) % m)


struct config {
    char *captureDevice;
    uint8 captureMethod;
    char *savedir;
    char *pidfile;
};

/* capture method macros */
#define CM_BPF 0
#define CM_PCAPLIVE 1
#define CM_PCAPFILE 2

extern void config_init( struct config*, int, char** );
extern void config_usage( char ** );

#endif
