#ifndef NITPICKER_FLOW_H
#define NITPICKER_FLOW_H

#include <time.h>
#include "ip.h"
#include <sys/queue.h>

struct flow_t {
   LIST_ENTRY( flow_t)  l_element;     /* next elem in bucket list */
   TAILQ_ENTRY(flow_t) tq_element;
   unsigned char           typenr;
   uint32                     sip;     /* src IP */
   uint32                     dip;     /* dst IP */
   uint32                 sdbytes;     /* bytes from src to dst */
   uint32                  sdpkts;     /* packets from src to dst */
   uint32                 dsbytes;     /* bytes from dst to src */ 
   uint32                  dspkts;     /* packets from dst to src */
   time_t               starttime;     /* timestamp of flow */
   uint16                  uptime;     /* uptime of flow */
   union ipprot              prot;
};

TAILQ_HEAD( flow_tqh, flow_t );

LIST_HEAD ( flow_lh,  flow_t );

extern void flow_init(  struct flow_t* );
extern void flow_print( struct flow_t* );

#endif
