#ifndef NITPICKER_SAVEFLOW_H
#define NITPICKER_SAVEFLOW_H

#include <sys/types.h>

#include "ip.h"

struct saveflow
{
   u_char typenr;
   uint16 startoffset;
   uint16 endoffset;
   uint32 sdpkts;
   uint32 sdbytes;
   uint32 dspkts;
   uint32 dsbytes;
   uint32 sip;
   uint32 dip;
   union ipprot prot;
} __attribute__((packed));

struct flowfileheader
{
    char magic[4];      /* The MagicNr.  - actual { 'N', 'P', 'F', 'F' } */
    char majver;        /* Major Version - actual '3' */
    char minver;        /* Minor Version */
    uint32 starttime;   /* First Flow in File */
    uint32 stoptime;    /* Oldes Flow in File */
    uint64 bytes;       /* Total Bytes of all Flows in File */
    uint32 flows;       /* Number of Flows in File */
    uint32 pkts;        /* Number of Packets in all Flows File */
    char unused[226];   /* Spare for further use ... */
} __attribute__((packed));  /* 256 Bytes should be reserved for hole flow */

extern void flowfileheader_init( struct flowfileheader * );

#endif
