#ifndef NITPICKER_CONFIG_H
#define NITPICKER_CONFIG_H

#include "types.h"


#define HASHSIZE        199961
#define MAXFLOWSINQUEUE   3000  /* Max size of timeQ (when reaching the limit, flows are directly moved to saveQ) */ 
#define FLOWSPERFILE     10000  /* How many Flows per Flowfile */
#define FLOWTIMEOUT        600  /* when flows are moved from timeQ into saveQ */

#define STATDELAY            3  /* Dump Statistics (Stats-Line) every n seconds */

#define BPFSIZE         8*1024*1024  /* 8MBytes could be enough */
#define BPFTIMEOUT      1            /* Read should timeout after 1 sec. */
#define SAVEDIR         "./current"
#define CAPDEVICE	""
#define PIDFILE		""

/* Return somd hash between 0 and m depending on the 32Bit p */
#define HASHFUNC(p,m) (((p)^((p)>>7)^((p)>>15)^((p)>>23)) % m)


struct config {
    char    capture_device[12];
    uint8   capture_method;
    char    savedir[256];
    char    pidfile[256];
    uint32  hashsize;
    uint32  max_flows_in_queue;
    uint32  flows_per_file;
    uint32  flow_timeout;         // in seconds
    uint32  bpf_size;
    uint32  bpf_timeout;          // in seconds
    uint32  stat_delay;
};

/* capture method macros */
#define CM_BPF 0
#define CM_PCAPLIVE 1
#define CM_PCAPFILE 2
#define CM_NONE 255

extern struct config* config_init( int, char** );
extern void config_usage();
extern void config_dump();

#endif
