#include <sys/types.h>

#include <stdio.h>
#include <string.h>
#include <netinet/in.h>

#include "flow.h"
#include "ip.h"


/**
 *  initialises a new flow
 */
void flow_init( struct flow_t* newflow )
{
    bzero( newflow, sizeof( struct flow_t ) );
}


/**
 * dumps the flow to stdout
 */
void flow_print( struct flow_t* curflow )
{
   char time[ 9 ];
   char ip[16]; 

   strftime( time, sizeof time, "%T", localtime( &curflow->starttime ) );

   switch( curflow->typenr ) {
       case TCPTYPE:
           printip(ip, curflow->sip );
           printf( "D:6(TCP) %s:%u",ip,htons( curflow->tcp_sport ) );
           printip(ip, curflow->dip  );
           printf( " %s:%u ", ip, htons( curflow->tcp_dport ) );
           break;

       case UDPTYPE:
           printip( ip, curflow->sip );
           printf( "D:17(UDP) %s:%u",ip,htons( curflow->udp_sport ) );
           printip(ip, curflow->dip );
           printf( " %s:%u ", ip, htons( curflow->udp_dport ) );
           break;

       case ICMPTYPE:
           printip( ip, curflow->sip );
           printf( "D:1(ICMP) %s", ip );
           printip( ip, curflow->dip );
           printf( " %s %u %u", ip, 
                   htons( curflow->icmp_type ), 
                   htons( curflow->icmp_subcode ) );
           break;

       default:
           printip( ip, curflow->sip );
           printf( "D:%u(OTH) %s", curflow->typenr, ip );
           printip( ip, curflow->dip );
           printf( " %s ",ip );
           break;
   }

   printf( " sdL:%lu dsL:%lu sdQ:%lu dsQ:%lu T:%s",
           curflow->sdbytes, curflow->dsbytes,
           curflow->sdpkts,  curflow->dspkts,
           time );
}
    
