#include <stdio.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include "mysignal.h"
#include "flowsaver.h"
#include "bpf.h"
#include "iphandler.h"
#include "nitpicker.h"

char state;

void debugsignal(int n) {
  printf("Got Signal:%d\n",n);
  fflush(stdout);
  exit(0);
}

void signalhandler_init( )
{
  signal(SIGHUP  , cleanup);
  signal(SIGINT  , cleankill); 
  signal(SIGQUIT , cleankill);
  signal(SIGTERM , cleankill); 

  state=ST_RUNNING;

}

void  blockall() {
  sigset_t old, new;

//  printf("N:Blocking\n");
//  fflush(stdout);

  sigaddset(&new, SIGHUP);
  sigaddset(&new, SIGINT);
  sigaddset(&new, SIGQUIT);
  sigaddset(&new, SIGTERM);

  sigprocmask(SIG_BLOCK, &new, &old);
}

void  unblockall() {
  sigset_t old, new;

//  printf("N:UnBlocking\n");
//  fflush(stdout);

  sigaddset(&new, SIGHUP);
  sigaddset(&new, SIGINT);
  sigaddset(&new, SIGQUIT);
  sigaddset(&new, SIGTERM);

  sigprocmask(SIG_UNBLOCK, &new, &old);

}

uint8 signalhandler_getstate()
{
    return state;
}

void cleankill( int dummy ) {

  printf("N:Caught KILL Signal .. ending operation and quit\n");
  fflush(stdout);

  state = ST_STOP;
}

void cleanup( int dummy )
{
  printf("N:Caught Signal .. dumping flows\n");
  fflush(stdout);

  state = ST_CLEANUP;
}
