#include <sys/stat.h> /* for rights */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> /* For open */
#include <unistd.h>
#include <stdlib.h>

#include "config.h"
#include "stats.h"
#include "nitpicker.h"
#include "ip.h"
#include "version.h"

struct _stats stats;
static uint32 statstamp;
static uint32 statdelay;

void init_stats( uint32 delay )
{
    statdelay = delay;

    bzero(&stats,sizeof (struct _stats));
    statstamp=0;
}

int is_stats_time(uint32 ts)
{
 if (ts > statstamp + statdelay ) {statstamp =ts; return 1;}
 else return 0;
}

void stats_update_iptype( unsigned char typenr, uint16 len )
{
    switch( typenr ) {
        case TCPTYPE:
           stats.tcp_bytes += len;
           stats.tcp_pktcnt++;
           break;
        case UDPTYPE:
           stats.udp_bytes += len;
           stats.udp_pktcnt++;
           break;
        case ICMPTYPE:
           stats.icmp_bytes += len;
           stats.icmp_pktcnt++;
           break;
        default:
           stats.other_bytes += len;
           stats.other_pktcnt++;
    }
}

void dump_stats()
{
 printf("S:%qu/%lu %lu/%lu %lu/%lu/%lu/%lu  %qu/%qu/%qu/%qu\n",

 stats.total_pktcnt,
 stats.total_dropped,

 stats.cflows_tq,
 stats.cflows_sq,

 stats.tcp_pktcnt,
 stats.udp_pktcnt,
 stats.icmp_pktcnt,
 stats.other_pktcnt,

 stats.tcp_bytes,
 stats.udp_bytes,
 stats.icmp_bytes,
 stats.other_bytes );

 fflush(stdout);

}
