#ifndef NITPICKER_STATS_H
#define NITPICKER_STATS_H

#include "types.h"

extern void init_stats( uint32 );
extern void dump_stats( void );

extern int is_stats_time( uint32 );
extern void stats_update_iptype( unsigned char, uint16 );


/* Statistics about packets/flows/etc.. */

struct _stats {

 uint32 cflows_tq;    /* Current Flows in Memory (timedQ) */
 uint32 cflows_sq;    /* Current Flows in Memory (SaveQ) */

 uint64 total_pktcnt;  /* Number of Total Packages seen */
 uint32 total_dropped; /* Numer of Packets dropped */

 uint32 ip_pktcnt;     /* Number of IP-Packets    seen */
 uint32 tcp_pktcnt;    /* Number of UDP-Packets   seen */
 uint32 udp_pktcnt;    /* Number of TCP-Packets   seen */
 uint32 icmp_pktcnt;   /* Number of ICMP-Packets  seen */
 uint32 other_pktcnt;  /* Number of Other-Packets seen */

 uint64 tcp_bytes;     /* Total TCP-Bytes   */
 uint64 udp_bytes;     /* Total UDP-Bytes   */
 uint64 icmp_bytes;    /* Total ICMP-Bytes  */
 uint64 other_bytes;   /* Total Other-Bytes */

};

extern struct _stats stats;

#endif
