#include <stdio.h>
#include <fcntl.h>
#include <sys/param.h>
#include <unistd.h>
#include <string.h>
#include <libgen.h>
#include <sys/time.h>
#include "types.h"
#include "convert.h"

/* 
 * Tool for parsing TXT OutputFiles from parse_flowfile  into a new flow-file....
 * Lets see 
 */


char *buildip (uint32 ipaddr)
{
  static char b[18];
  unsigned int i1,i2,i3,i4;
  
  i1 = ipaddr >> 24 ;
  i2 = (ipaddr >> 16 ) & 0xff;
  i3 = (ipaddr >> 8) & 0xff;
  i4 = ipaddr & 0xff;
  
  sprintf(b,"%u.%u.%u.%u",i1,i2,i3,i4);
  return (b);
}


uint32 now()
{
   struct timeval tv;

   gettimeofday(&tv, 0);                             
   return (tv.tv_sec);
}



int main( int argc, char* argv[] )
{
    int outfile, retval;
    FILE *infile;
    struct v3header v3head; 
    struct v3flow   v3flw; 
    u_char flowtype=0; /* tcp, udp, other ... */
    char outfilename[22];
    char customer[200];
    uint64 inbytes,outbytes;
    unsigned int i1,i2,i3,i4;

    if( argc < 2 ) {
        printf( "%s <inputfile> \n", argv[0] );
        exit( 1 );
    }

    infile = fopen( argv[1], "r" );

    if( ! infile ) {
        perror( "while opening input file" );
        exit( 1 );
    }

    flowtype=1; 

    printf("%s is %d\n",basename(argv[1]), flowtype );

    sprintf(outfilename,"flow.%lu.s",now() );
    printf("Using %s as outfile\n", outfilename);
    outfile = open( outfilename , O_RDWR | O_CREAT | O_TRUNC, 0666 );

    if( ! outfile ) {
        perror( "while opening output file" );
        exit (1);
    }

    bzero(&v3head,sizeof( struct v3header) ); 
    retval = write( outfile, &v3head, sizeof( struct v3header ) );
    if (!retval) {
       perror("Write outfile header\n");
       exit(1);
    }


    while (!feof(infile))
    {

       retval= fscanf(infile,"%s%u.%u.%u.%u %qu %qu\n", 
               customer, &i1, &i2, &i3, &i4, &inbytes, &outbytes);
    
       if( retval == 7 ) {

          v3flw.startoffset = 0;
          v3flw.endoffset = 0;
          v3flw.sdpkts = 0 ;
          v3flw.sdbytes = htonl (outbytes) ;
          v3flw.dspkts = 0 ;
          v3flw.dsbytes = htonl (inbytes)  ;

          v3flw.src    = htonl( (i1<<24)+(i2<<16)+(i3<<8)+i4 ); 
          v3flw.dst    = 0 ;
          v3flw.typenr = 1;
  
          write(outfile,&v3flw,sizeof(struct v3flow) );
      }  
      else {
         printf("No:\n");
      }
   }

   fclose( infile );
    
   strncpy(v3head.MagicNr, "NPFF",4 );

   v3head.MajVersion = 3;
   v3head.MinVersion = 1;

   lseek( outfile, 0, SEEK_SET );  
   write( outfile, &v3head, sizeof( struct v3header ) );

   close( outfile );
    
   return 0;
}

